<template>
  <div :class="['w-fit max-w-[184px] rounded-[8px] flex gap-2 items-center justify-start', getChipClass(), getChipSize(), tagStyle === 'text' ? '!px-0' : '']">
    <div
      v-if="leadingItem === 'point'"
      class="flex rounded-full"
      :class="[`bg-${getTextColor()}`, tagStyle === 'default' ? 'w-2 h-2' : 'w-1.5 h-1.5']"
    />

    <div v-if="leadingItem === 'icon' && icon">
      <Icon
        width="18"
        height="18"
        :icon="icon"
        :class="`text-${getTextColor()}`"
      />
    </div>

    <svn-pro-text
      :bodyMedium="tagSize === 'default'"
      :medium="tagSize === 'default'"
      :caption="tagSize === 'compact'"
      :color="getTextColor()"
      class="line-clamp-1"
      :class="breakAll ? 'break-all' : ''"
    >
      {{ text }}
    </svn-pro-text>
  </div>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import SvnProText from "../styles/SvnProText.vue"

const props = defineProps({
  text: {
    type: String,
    default: undefined,
  },
  tagType: {
    type: String,
    default: "primary",
  },
  tagSize: {
    type: String,
    default: "default",
  },
  tagStyle: {
    type: String,
    default: "filled",
  },
  leadingItem: {
    type: String,
    default: undefined,
  },
  breakAll: {
    type: Boolean,
    default: false,
  },
  icon: {
    type: String,
    default: undefined,
  },
});

const getChipClass = () => {
  if (props.tagStyle === "filled") {
    if (props.tagType === "primary") {
      return "bg-primary"
    } else if (props.tagType === "success") {
      return "bg-success"
    } else if (props.tagType === "warning") {
      return "bg-warning"
    } else if (props.tagType === "error") {
      return "bg-error"
    } else if (props.tagType === "info") {
      return "bg-surfaceLight"
    }
  } else if (props.tagStyle === "outlined") {
    if (props.tagType === "primary") {
      return "border border-primary border-opacity-100"
    } else if (props.tagType === "success") {
      return "border border-success border-opacity-100"
    } else if (props.tagType === "warning") {
      return "border border-warning border-opacity-100"
    } else if (props.tagType === "error") {
      return "border border-error border-opacity-100"
    } else if (props.tagType === "info") {
      return "border border-info border-opacity-100"
    }
  }
}

const getChipSize = () => {
  if (props.tagSize === 'default') {
    if (props.leadingItem) {
      return "h-8 pl-2 pr-3 py-1"
    } else {
      return "h-8 px-3 py-1"
    }
  } else if (props.tagSize === 'compact') {
    if (props.leadingItem) {
      return "h-6 pl-2 pr-3 py-0.5"
    } else {
      return "h-6 px-3 py-0.5"
    }
  }
}

const getTextColor = () => {
  if (props.tagStyle === "filled") {
    if (props.tagType === "primary") {
      return "onPrimary"
    } else if (props.tagType === "success") {
      return "onSuccess"
    } else if (props.tagType === "warning") {
      return "onWarning"
    } else if (props.tagType === "error") {
      return "onError"
    } else if (props.tagType === "info") {
      return "onSurface"
    }
  } else if (props.tagStyle === "outlined" || props.tagStyle === "text") {
    if (props.tagType === "primary") {
      return "primary"
    } else if (props.tagType === "success") {
      return "success"
    } else if (props.tagType === "warning") {
      return "warning"
    } else if (props.tagType === "error") {
      return "error"
    } else if (props.tagType === "info") {
      return "onSurface"
    }
  }
}
</script>